/*
    Garfield Widget
    Written By: Gregory Jay
    Modified By: Chris Foot

    Garfield cartoons are property of Paws, inc
*/
function OnClickComic()
{
var date=GetComicPageDate();
var garfielddate=date.substring(2,8);
    openURL("http://www.garfield.com/comics/comics_archives_strip.html?" + myDate.getFullYear() + "-ga" + garfielddate);
}
function rolls()
{
cHeight = comic.srcHeight;
cHeight2 = comic.height + 20;
cHeight3 = 0 - cHeight2; 

if (drops == 1)
{
	var a = new MoveAnimation(bottom,0,-25,300,animator.kEaseInOut);
	var b = new MoveAnimation(legalText,legalText.hOffset,-25,300,animator.kEaseInOut);
	var c = new MoveAnimation(right,right.hOffset,-25,300,animator.kEaseInOut);
	var d = new MoveAnimation(left,left.hOffset,-25,300,animator.kEaseInOut);
	var e = new MoveAnimation(nextText,nextText.hOffset,-25,300,animator.kEaseInOut);
	var f = new MoveAnimation(prevText,prevText.hOffset,-25,300,animator.kEaseInOut);
	var g = new MoveAnimation(comic,0,cHeight3,300,animator.kEaseInOut);
	animator.runUntilDone( new Array(a, b, c, d, e, f , g));

	var a = new MoveAnimation(top,-350,0,300,animator.kEaseInOut);
	animator.runUntilDone( new Array(a, b));


	drops=0;
}

else if (drops == 0)
{
	var a = new MoveAnimation(top,0,00,300,animator.kEaseInOut);
	animator.runUntilDone( new Array(a, b));

	var a = new MoveAnimation(bottom,0,cHeight2,300,animator.kEaseInOut);
	var b = new MoveAnimation(legalText,legalText.hOffset,cHeight2 + 15,300,animator.kEaseInOut);
	var c = new MoveAnimation(right,right.hOffset,cHeight2,300,animator.kEaseInOut);
	var d = new MoveAnimation(left,left.hOffset,cHeight2,300,animator.kEaseInOut);
	var e = new MoveAnimation(nextText,nextText.hOffset,cHeight2 + 15,300,animator.kEaseInOut);
	var f = new MoveAnimation(prevText,prevText.hOffset,cHeight2 + 15,300,animator.kEaseInOut);
	var g = new MoveAnimation(comic,0,20,300,animator.kEaseInOut);
	animator.runUntilDone( new Array(a, b, c, d, e, f , g));


  	drops=1;

}
}

function GetComicPageDate()
{
    var imageString = myDate.getFullYear();
    var month = myDate.getMonth() + 1;
    if (month < 10)
        imageString += "0";
    imageString += month;
    if (myDate.getDate() < 10)
        imageString += "0";
    imageString += myDate.getDate();
    imageString += ".html";
    return imageString;
}

function GetImageDate()
{
    var imageString = myDate.getFullYear();
    var month = myDate.getMonth() + 1;
    if (month < 10)
        imageString += "0";
    imageString += month;
    if (myDate.getDate() < 10)
        imageString += "0";
    imageString += myDate.getDate();
    imageString += ".gif";
    return imageString;
}

function PrevComic()
{
    moveDateDir = 0;

    var myTime = myDate.getTime();
    myTime -= 86400000;
    myDate.setTime(myTime);
    LoadComic();
}

function CheckForNewDay()
{
	var curDate = new Date();
	if (compareDates(curDate, todayDate) != 0)
	{
		log("New Day");
		moveDateDir = 0;
		todayDate = curDate;
		myDate = new Date();

		LoadComic();
		rolls();
	}
}

function compareDates(date1, date2)
{
    if (date1.getYear() > date2.getYear())
        return 1;
    else if (date1.getYear() < date2.getYear())
        return -1;

    if (date1.getMonth() > date2.getMonth())
        return 1;
    else if (date1.getMonth() < date2.getMonth())
        return -1;

    if (date1.getDate() > date2.getDate())
        return 1;
    else if (date1.getDate() < date2.getDate())
        return -1;

    return 0;
}

function NextComic()
{
    if (saveDate == null)
    {
        saveDate = new Date();
        saveDate.setTime(myDate.getTime());
    }

    moveDateDir = 1;

    var myTime = myDate.getTime();
    myTime += 86400000;
    myDate.setTime(myTime);

    if (compareDates(myDate, todayDate) == 1)
    {
        myDate = saveDate;
        saveDate = null;
        log("No Next");
        return;
    }

    LoadComic();
}

function GetComicTitle(contents)
{
    /*
    var place = contents.indexOf("<i>");
    if (place <= 0)
        return "";
    contents = contents.substring(place+3);
    place = contents.indexOf("</i>");
    if (place <= 0)
        return "";
    contents = contents.substring(0, place);
    */

    /*
    Set to comic name because the page doesn't contain the episode name
    */
    contents = "Garfield";
    return contents;
}

function LoadComic()
{
    var webpageUrl = new URL();
var date=GetComicPageDate();
var garfielddate=date.substring(2,8);
    var title = GetComicTitle(new String(contents));
var contents = "http://images.ucomics.com/comics/ga/" + myDate.getFullYear() + "/ga" + garfielddate + ".gif";
webpageUrl.location = contents;
var isimage = webpageUrl.fetch();
var regExp = /404/; 
var isimage = isimage.match(regExp);
if (!(isimage == "404"))
{

    if (comic.src == contents)
    {
        if (moveDateDir == 0)
            PrevComic();
        else
            NextComic();
        return;
    }

    log("Title: " + title);
    titleText.data = title;

    saveDate = null;

    var myImage = new Image();
    myImage.src = contents;
    comic.src = myImage.src;
    log("Getting: " + comic.src);

    comic.width = myImage.width / 1.3;
    comic.height = myImage.height / 1.3;
    comic.vOffset = top.height;

    top.width = comic.width;

    var sizeOfText = titleText.data.length * 9.8 + 10;
    titleText.size = 16;
    titleText.hOffset = 10;
    titleText.vOffset = 15;

    if (sizeOfText > top.width)
        titleText.size = 12;

    bottom.vOffset = comic.height + top.height;
    bottom.width = comic.width;

    left.vOffset = bottom.vOffset;
    left.hOffset = 10;

    prevText.vOffset = bottom.vOffset + 17;
    prevText.hOffset = left.hOffset + left.width + 2;

    right.vOffset = bottom.vOffset;
    right.hOffset = comic.width - right.width - 10;

    nextText.vOffset = bottom.vOffset + 17;
    nextText.hOffset = right.hOffset - 38;

    var half = legalText.data.length / 2;
    legalText.vOffset = bottom.vOffset + 15;
    legalText.hOffset = comic.width / 2 - half  * 4.8;

    mainWindow.width = comic.width;
    mainWindow.height = comic.height + bottom.height + top.height;

    mainWindow.vOffset = origVOffset;
    mainWindow.hOffset = origHOffset;
    adjustedHOffset = mainWindow.hOffset;
    adjustedVOffset = mainWindow.vOffset;
    adjustedDisplay = false;
    drops = 1;

    if (screen.availHeight < (mainWindow.vOffset + mainWindow.height))
    {
        mainWindow.vOffset -= mainWindow.height + mainWindow.vOffset 
            - screen.availHeight;
        adjustedVOffset = mainWindow.vOffset;
        adjustedDisplay = true;
    }

    if (screen.availWidth < (mainWindow.hOffset + mainWindow.width))
    {
        mainWindow.hOffset -= mainWindow.width + mainWindow.hOffset 
            - screen.availWidth;
        adjustedHOffset = mainWindow.hOffset;
        adjustedDisplay = true;
    }
}
else {
log ("No new comic");
PrevComic();
}
}



todayDate = new Date();
moveDateDir = 0;
myDate = new Date();

origHOffset = mainWindow.hOffset;
origVOffset = mainWindow.vOffset;
adjustedHOffset = mainWindow.hOffset;
adjustedVOffset = mainWindow.vOffset;
adjustedDisplay = false;
LoadComic();
